//----------------------------------------------------------------------------
// C main line			// Adresse I2C 0x40
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
					
int i;
int valdep,valfin,val;
BYTE    Donnee[2]={0xAA,0x55};  
BYTE    status,fin;

void main()
{
	Timer8_1_EnableInt();
	M8C_EnableGInt;
	LCD_1_Start();
	LCD_1_PrCString("Distance obst. :");
	DigInv_1_Start();								
	PGA_1_Start(PGA_1_HIGHPOWER);
	PGA_2_Start(PGA_2_HIGHPOWER);
	BPF2_1_Start(BPF2_1_HIGHPOWER);
	CMPPRG_1_Start(CMPPRG_1_HIGHPOWER);
	I2CHW_1_Start();  
    I2CHW_1_EnableSlave();
    I2CHW_1_InitRamRead(Donnee,2);  
    I2CHW_1_InitWrite(Donnee,0);	// pas d'�criture
    I2CHW_1_EnableInt(); 
	fin=0;
	
	while (1)
	{
		status = I2CHW_1_bReadI2CStatus();  
        // Attente que les donn�es soient lues par le ma�tre
        if( (status & I2CHW_RD_COMPLETE )==I2CHW_RD_COMPLETE)  
        {	I2CHW_1_ClrRdStatus();  
	        // Reinitialise le pointeur pour prochaine lecture
	        I2CHW_1_InitRamRead(Donnee,2);
	        // lance une nouvelle mesure 
        	Timer8_1_Start();
    		valdep=Counter16_1_wReadCounter();
    		Counter16_1_Start();
    		fin=0;
    		while(fin==0)
    		{
    			val=valdep-Counter16_1_wReadCounter();
    			if (val>30000) 
    			{
    				fin=1;	// obstacle hors port�e (>5m)
    				Donnee[1]=0xFF;
    				Donnee[0]=0xFF;
    			}
    			else
    			{		// augmentation du gain quand la distance de l'obstacle augmente (3 niveaux)
    				if(val>3500) PGA_2_SetGain(PGA_2_G16_0);
    				else 
    				{	if(val>2000) PGA_2_SetGain(PGA_2_G8_00);
    					else PGA_2_SetGain(PGA_2_G4_00);
    				}	
    			}
    		}
    	}							
    }
}

#pragma interrupt_handler timer8_isr
void timer8_isr()
{
	i++;
	if (i==8) 
	{	Timer8_1_Stop();
		i=0;
		M8C_ClearIntFlag(INT_CLR0,INT_MSK0_ACOLUMN_2);
    	M8C_EnableIntMask(INT_MSK0, INT_MSK0_ACOLUMN_2);	//autorisation inter sur front montant 
	}													// "comparator 2" analogique
}

#pragma interrupt_handler analog2_isr	// ljmp _detection_isr dans boot.tpl sur inter analog 2
void analog2_isr()
{
	Counter16_1_Stop();
	M8C_DisableIntMask(INT_MSK0, INT_MSK0_ACOLUMN_2);
	valfin=Counter16_1_wReadCounter();
	fin=1;
	val=valdep-valfin;	//le compteur decompte ! 
	val=val/119;		// distance en cm avec horloge 2MHz
	Donnee[1]=(val & 0x00FF);
    Donnee[0]=(val>>8); 
	LCD_1_Position(1,5);
	LCD_1_PrHexInt(val);
	LCD_1_PrCString("cm");
}